# Generated by Django 4.1.7 on 2023-03-29 13:53

import django.core.validators
import django.db.models.deletion
import mysite.validators
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Address',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                ('apartment', models.CharField(blank=True, max_length=255)),
                (
                    'address',
                    models.CharField(default='123 Fake Street', max_length=255),
                ),
                ('city', models.CharField(max_length=255)),
                ('state_or_province', models.CharField(max_length=255)),
                ('country', models.CharField(max_length=255)),
                ('zip_or_postal_code', models.CharField(max_length=255)),
            ],
            options={
                'verbose_name': 'Address',
                'verbose_name_plural': 'Addresses',
            },
        ),
        migrations.CreateModel(
            name='Order',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                ('order_date', models.DateTimeField(auto_now_add=True)),
                (
                    'user',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                'verbose_name': 'Order',
                'verbose_name_plural': 'Orders',
            },
        ),
        migrations.CreateModel(
            name='Product',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                (
                    'name',
                    models.CharField(
                        max_length=255,
                        validators=[django.core.validators.MinLengthValidator(3)],
                    ),
                ),
                (
                    'color',
                    models.CharField(
                        choices=[
                            ('red', 'Red'),
                            ('orange', 'Orange'),
                            ('yellow', 'Yellow'),
                            ('green', 'Green'),
                            ('blue', 'Blue'),
                            ('indigo', 'Indigo'),
                            ('violet', 'Violet'),
                            ('black', 'Black'),
                            ('white', 'White'),
                        ],
                        max_length=6,
                    ),
                ),
                ('unit_price', models.DecimalField(decimal_places=2, max_digits=15)),
                ('is_discontinued', models.BooleanField(default=False)),
                (
                    'image',
                    models.ImageField(
                        null=True,
                        upload_to='products/images/%Y/%m/%d/',
                        validators=[mysite.validators.MimeTypeValidator('image/png')],
                    ),
                ),
            ],
            options={
                'verbose_name': 'Product',
                'verbose_name_plural': 'Products',
            },
        ),
        migrations.CreateModel(
            name='Supplier',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                (
                    'company_name',
                    models.CharField(
                        max_length=255,
                        validators=[django.core.validators.MinLengthValidator(3)],
                    ),
                ),
                ('contact_name', models.CharField(blank=True, max_length=255)),
                ('phone', models.CharField(blank=True, max_length=15)),
                (
                    'email',
                    models.CharField(
                        blank=True,
                        max_length=255,
                        unique=True,
                        validators=[django.core.validators.EmailValidator()],
                    ),
                ),
                (
                    'hq_address',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.address',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Supplier',
                'verbose_name_plural': 'Suppliers',
            },
        ),
        migrations.CreateModel(
            name='WarehouseAddress',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                (
                    'address',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.address',
                    ),
                ),
                (
                    'supplier',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.supplier',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Warehouse Address',
                'verbose_name_plural': 'Warehouse Addresses',
            },
        ),
        migrations.CreateModel(
            name='SupplierInventoryItem',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                ('product_quantity', models.PositiveIntegerField()),
                (
                    'product',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.product',
                    ),
                ),
                (
                    'supplier',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.supplier',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Supplier Inventory Item',
                'verbose_name_plural': 'Supplier Inventory Items',
            },
        ),
        migrations.CreateModel(
            name='OrderItem',
            fields=[
                (
                    'id',
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name='ID',
                    ),
                ),
                ('quantity', models.PositiveIntegerField()),
                (
                    'order',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to='demo_app.order'
                    ),
                ),
                (
                    'product',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='demo_app.product',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Order Item',
                'verbose_name_plural': 'Order Items',
            },
        ),
    ]
